package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class showlist extends Activity implements B4AActivity{
	public static showlist mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.showlist");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (showlist).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.showlist");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        anywheresoftware.b4a.keywords.Common.Log("** Activity (showlist) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (showlist) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return showlist.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (showlist) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (showlist) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnlog = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnllog = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _svlog = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtlog = null;
public main _main = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 22;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 25;BA.debugLine="Activity.LoadLayout(\"Lister\")";
mostCurrent._activity.LoadLayout("Lister",mostCurrent.activityBA);
 //BA.debugLineNum = 26;BA.debugLine="Init";
_init();
 //BA.debugLineNum = 28;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 34;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 30;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 32;BA.debugLine="End Sub";
return "";
}
public static String  _btn_click() throws Exception{
 //BA.debugLineNum = 82;BA.debugLine="Sub btn_Click";
 //BA.debugLineNum = 83;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 //BA.debugLineNum = 84;BA.debugLine="End Sub";
return "";
}
public static String  _getrs(String _txtin) throws Exception{
String _txtout = "";
int _ht = 0;
anywheresoftware.b4a.objects.StringUtils _su = null;
anywheresoftware.b4a.agraham.richstring.RichStringBuilder.RichString _rs = null;
anywheresoftware.b4a.agraham.richstring.RichStringBuilder _rsb = null;
anywheresoftware.b4a.agraham.richstring.RichStringBuilder.RichStringFormatter _rsf = null;
 //BA.debugLineNum = 47;BA.debugLine="Sub GetRS (TxtIn As String)";
 //BA.debugLineNum = 48;BA.debugLine="Dim TxtOut As String";
_txtout = "";
 //BA.debugLineNum = 49;BA.debugLine="Dim Ht As Int";
_ht = 0;
 //BA.debugLineNum = 50;BA.debugLine="Dim SU As StringUtils";
_su = new anywheresoftware.b4a.objects.StringUtils();
 //BA.debugLineNum = 51;BA.debugLine="Dim rs As RichString";
_rs = new anywheresoftware.b4a.agraham.richstring.RichStringBuilder.RichString();
 //BA.debugLineNum = 52;BA.debugLine="Dim rsb As RichStringBuilder";
_rsb = new anywheresoftware.b4a.agraham.richstring.RichStringBuilder();
 //BA.debugLineNum = 53;BA.debugLine="Dim rsf As RichStringFormatter";
_rsf = new anywheresoftware.b4a.agraham.richstring.RichStringBuilder.RichStringFormatter();
 //BA.debugLineNum = 56;BA.debugLine="rsf.Initialize(\"{sample}\")";
_rsf.Initialize("{sample}");
 //BA.debugLineNum = 59;BA.debugLine="rsf.AddToken(\"{Green}\", rsf.FORMAT_COLOR, Colors.Green)";
_rsf.AddToken("{Green}",_rsf.FORMAT_COLOR,BA.NumberToString(anywheresoftware.b4a.keywords.Common.Colors.Green));
 //BA.debugLineNum = 60;BA.debugLine="rsf.AddToken(\"{Red}\", rsf.FORMAT_COLOR, Colors.Red)";
_rsf.AddToken("{Red}",_rsf.FORMAT_COLOR,BA.NumberToString(anywheresoftware.b4a.keywords.Common.Colors.Red));
 //BA.debugLineNum = 61;BA.debugLine="rsf.AddToken(\"{I}\", rsf.FORMAT_STYLE, rsf.STYLE_ITALIC)";
_rsf.AddToken("{I}",_rsf.FORMAT_STYLE,BA.NumberToString(_rsf.STYLE_ITALIC));
 //BA.debugLineNum = 62;BA.debugLine="rsf.AddToken(\"{B}\", rsf.FORMAT_STYLE, rsf.STYLE_BOLD)";
_rsf.AddToken("{B}",_rsf.FORMAT_STYLE,BA.NumberToString(_rsf.STYLE_BOLD));
 //BA.debugLineNum = 65;BA.debugLine="rs.Initialize(\"\")";
_rs.Initialize((java.lang.CharSequence)(""));
 //BA.debugLineNum = 66;BA.debugLine="rs.Initialize(TxtIn)";
_rs.Initialize((java.lang.CharSequence)(_txtin));
 //BA.debugLineNum = 69;BA.debugLine="rs = rsf.Format(rs)";
_rs = _rsf.Format((android.text.SpannableString)(_rs.getObject()));
 //BA.debugLineNum = 72;BA.debugLine="txtLog.Text = rs";
mostCurrent._txtlog.setText((Object)(_rs.getObject()));
 //BA.debugLineNum = 73;BA.debugLine="Ht = SU.MeasureMultilineTextHeight(txtLog, txtLog.Text) 'Measure the height of the label text.";
_ht = _su.MeasureMultilineTextHeight((android.widget.TextView)(mostCurrent._txtlog.getObject()),mostCurrent._txtlog.getText());
 //BA.debugLineNum = 74;BA.debugLine="If Ht > svLog.Panel.Height Then";
if (_ht>mostCurrent._svlog.getPanel().getHeight()) { 
 //BA.debugLineNum = 75;BA.debugLine="svLog.Panel.Height = Ht + 48";
mostCurrent._svlog.getPanel().setHeight((int)(_ht+48));
 //BA.debugLineNum = 76;BA.debugLine="txtLog.Height = svLog.Panel.Height";
mostCurrent._txtlog.setHeight(mostCurrent._svlog.getPanel().getHeight());
 };
 //BA.debugLineNum = 79;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
             try {
                Class.forName(BA.applicationContext.getPackageName() + ".main").getMethod("initializeProcessGlobals").invoke(null, null);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 16;BA.debugLine="Dim btnLog As Button 'Used to return to the first screen.";
mostCurrent._btnlog = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 17;BA.debugLine="Dim pnlLog As Panel";
mostCurrent._pnllog = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 18;BA.debugLine="Dim svLog As ScrollView 'Holds the Label for scrolling the list.";
mostCurrent._svlog = new anywheresoftware.b4a.objects.ScrollViewWrapper();
 //BA.debugLineNum = 19;BA.debugLine="Dim txtLog As EditText 'Where the list will be displayed.";
mostCurrent._txtlog = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
public static String  _init() throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub Init";
 //BA.debugLineNum = 39;BA.debugLine="txtLog.Initialize(\"\")";
mostCurrent._txtlog.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 40;BA.debugLine="txtLog.Gravity = Gravity.TOP";
mostCurrent._txtlog.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.TOP);
 //BA.debugLineNum = 41;BA.debugLine="svLog.Panel.AddView(txtLog, svLog.Left + 10, svLog.Top, svLog.Width - 20, svLog.Height)";
mostCurrent._svlog.getPanel().AddView((android.view.View)(mostCurrent._txtlog.getObject()),(int)(mostCurrent._svlog.getLeft()+10),mostCurrent._svlog.getTop(),(int)(mostCurrent._svlog.getWidth()-20),mostCurrent._svlog.getHeight());
 //BA.debugLineNum = 42;BA.debugLine="GetRS(File.ReadString(File.DirRootExternal, \"Log.txt\"))";
_getrs(anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"Log.txt"));
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 6;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 10;BA.debugLine="End Sub";
return "";
}
}
