﻿Type=Activity
Version=2.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Dim btnLog As Button 'Used to return to the first screen.
	Dim pnlLog As Panel
	Dim svLog As ScrollView 'Holds the Label for scrolling the list.
	Dim txtLog As EditText 'Where the list will be displayed.
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	Activity.LoadLayout("Lister")
	Init

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Init
	txtLog.Initialize("")
	txtLog.Gravity = Gravity.TOP
	svLog.Panel.AddView(txtLog, svLog.Left + 10, svLog.Top, svLog.Width - 20, svLog.Height)
	GetRS(File.ReadString(File.DirRootExternal, "Log.txt"))
	
End Sub

'Formats the string provided to TxtIn and returns the formatted string in TxtOut.
Sub GetRS (TxtIn As String)
	Dim TxtOut As String
	Dim Ht As Int
	Dim SU As StringUtils
	Dim rs As RichString
	Dim rsb As RichStringBuilder
	Dim rsf As RichStringFormatter
	
	'Initialize the RichString formatter.
	rsf.Initialize("{sample}")

	'set the tokens to be used in formatting
	rsf.AddToken("{Green}", rsf.FORMAT_COLOR, Colors.Green)
	rsf.AddToken("{Red}", rsf.FORMAT_COLOR, Colors.Red)
	rsf.AddToken("{I}", rsf.FORMAT_STYLE, rsf.STYLE_ITALIC)
	rsf.AddToken("{B}", rsf.FORMAT_STYLE, rsf.STYLE_BOLD)
	
	'Initialize the RichString.
	rs.Initialize("")
	rs.Initialize(TxtIn)

	'Format the string
	rs = rsf.Format(rs)
	
	'Display the formatted string
	txtLog.Text = rs
	Ht = SU.MeasureMultilineTextHeight(txtLog, txtLog.Text) 'Measure the height of the label text.
	If Ht > svLog.Panel.Height Then
		svLog.Panel.Height = Ht + 48
		txtLog.Height = svLog.Panel.Height
	End If

End Sub


Sub btn_Click
	Activity.Finish
End Sub